package net.mc_pandacraft.java.plugin.pandacraftutils.data_model;

public class ModoHistoryElement extends SQLElement {
	
	private String modoName;
	private ActionType actionType;
	private long time;
	private String playerName;
	private Long duration = null;
	private String message;
	

	public ModoHistoryElement(String modo, ActionType type, long time, String player, String message) {
		super("pandacraft_modo_history");
		setModoName(modo);
		setActionType(type);
		setTime(time);
		setPlayerName(player);
		setMessage(message);
	}
	
	ModoHistoryElement(int id, String modo, ActionType type, long time, String player, String message) {
		super("pandacraft_modo_history", id);
		setModoName(modo);
		setActionType(type);
		setTime(time);
		setPlayerName(player);
		setMessage(message);
	}

	@Override
	protected String[] getValues() {
		return new String[] {
				modoName,
				actionType.name(),
				String.valueOf(time),
				playerName,
				(duration == null)?null:duration.toString(),
				message
		};
	}

	@Override
	protected String[] getFieldsName() {
		return new String[] {
				"modoName",
				"actionType",
				"time",
				"playerName",
				"duration",
				"message"
		};
	}
	
	
	
	public String getModoName() {
		return modoName;
	}

	public void setModoName(String modoName) {
		if (modoName == null) throw new IllegalArgumentException("le paramètre ne peut être null");
		this.modoName = modoName;
	}



	public ActionType getActionType() {
		return actionType;
	}

	public void setActionType(ActionType actionType) {
		if (actionType == null) throw new IllegalArgumentException("le paramètre ne peut être null");
		this.actionType = actionType;
	}



	public long getDuration() {
		return duration;
	}

	public void setDuration(Long duration) {
		if (duration != null && duration.longValue() < 0) duration = null;
		this.duration = duration;
	}



	public String getPlayerName() {
		return playerName;
	}

	public void setPlayerName(String playerName) {
		if (playerName == null) throw new IllegalArgumentException("le paramètre ne peut être null");
		this.playerName = playerName;
	}


	public String getMessage() {
		return message;
	}

	public void setMessage(String message) {
		if (message == null) throw new IllegalArgumentException("le paramètre ne peut être null");
		this.message = message;
	}







	public long getTime() {
		return time;
	}

	public void setTime(long time) {
		this.time = time;
	}







	public enum ActionType{
		TEMPBAN, MUTE, JAIL, REPORT, KICK, MONEY
	}

}
